<?php

namespace plugin\inspection\controller\api;

use plugin\inspection\model\InspectionStaff;
use plugin\inspection\model\InspectionStaffToken;
use think\admin\Controller;
use think\admin\model\SystemUser;

class Login extends Controller
{
    public function login()
    {
        $this->title = '登录';
        if ($this->request->post('phone')) {
            $where = $this->_vali([
                'phone.require' => '手机号码不能为空',
            ]);
        } else {
            $where = $this->_vali([
                'account.require' => '登录账号不能为空',
            ]);
        }
        $staff = InspectionStaff::mk()->where($where)->findOrEmpty();
        ["password" => $password] = $this->_vali([
            'password.require' => '登录密码不能为空',
        ]);
        if ($staff->isEmpty()) {
            // 可能是后台用户登录
            $map = ['username' => $where['phone'] ?? $where['account'], 'is_deleted' => 0];
            $user = SystemUser::mk()->where($map)->findOrEmpty();
            if ($user->isEmpty()) {
                $this->error('用户不存在');
            } else {
                if ($user->password !== md5($password)) {
                    $this->error('密码错误');
                }
                $token = md5(uniqid());
                InspectionStaffToken::query()->where('is_admin', '=', 1)->where('staff_id', '=', $user->id)->delete();
                InspectionStaffToken::mk([
                    'staff_id' => $user->id,
                    'token' => $token,
                    "is_admin" => 1,
                ])->save();
                $this->success('登录成功', [
                    'is_admin'=> true,
                    'token' => $token,
                    'user' => $user->toArray(),
                ]);
            }
        } else {
            if ($staff->password !== $password) {
                $this->error('密码错误');
            }
            $this->staff->save(['last_login_at' => date('Y-m-d H:i:s')]);
            $this->staff->tokens()->where('token', '<>', '')->delete();
            $this->success('登录成功', [
                'is_admin' => false,
                'token' => $this->staff->tokens()->save(['token' => md5(uniqid())])->token,
                'user' => $this->staff->toArray(),
            ]);
        }

    }
}