<?php

namespace plugin\points_mall\controller\api\auth;

use plugin\points_mall\controller\api\Auth;
use plugin\points_mall\model\PointsMallAddress;
use think\admin\helper\QueryHelper;

class Address extends Auth
{
    public function list()
    {
        PointsMallAddress::mQuery(null, function (QueryHelper $query) {
            $query->where("unid", $this->usid);
            $this->success('获取成功！', $query->select(), false, false, 10);
        });
    }

    public function info()
    {
        $data = $this->_vali([
            "id.require" => "获取失败，请稍候再试！",
            "unid.value" => $this->usid,
        ]);
        $this->success('获取成功！', PointsMallAddress::query()->where($data)->find());
    }

    public function save()
    {
        $data = $this->request->post();
        $data['unid'] = $this->usid;
        if (empty($data['id']) || $data['id'] == 0) {
            unset($data['id']);
            $pointsMallAddress = PointsMallAddress::create($data);
        } else {
            $pointsMallAddress = PointsMallAddress::find($data['id']);
            if ($pointsMallAddress->unid != $this->usid) {
                $this->error('非法操作！');
            }
        }
        if ($pointsMallAddress->save($data)) {
            $this->success('保存成功！');
        } else {
            $this->error('保存失败！');
        }
    }

    public function delete()
    {
        $input = $this->_vali([
            "id.require" => "删除失败，请稍候再试！",
            "unid.value" => $this->usid,
        ]);
        if (PointsMallAddress::query()->where($input)->delete()) {
            $this->success('删除成功！');
        } else {
            $this->error('删除失败！');
        }
    }
}